'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _get = function get(_x2, _x3, _x4) { var _again = true; _function: while (_again) { var object = _x2, property = _x3, receiver = _x4; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x2 = parent; _x3 = property; _x4 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _graphql = require('graphql');

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _joi = require('joi');

var _joi2 = _interopRequireDefault(_joi);

var GraphQLJoiType = (function (_GraphQLScalarType) {
  _inherits(GraphQLJoiType, _GraphQLScalarType);

  function GraphQLJoiType() {
    var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

    _classCallCheck(this, GraphQLJoiType);

    var name = options.name;
    var schema = options.schema;
    var description = schema._description;

    (0, _assert2['default'])(!_lodash2['default'].isEmpty(name), 'required name argument');
    (0, _assert2['default'])(schema.isJoi, 'joi schema required');
    _get(Object.getPrototypeOf(GraphQLJoiType.prototype), 'constructor', this).call(this, {
      name: name,
      description: description,
      serialize: function serialize(value) {
        return value;
      },
      parseValue: function parseValue(value) {
        return value;
      },
      parseLiteral: function parseLiteral(ast) {
        var value = undefined;
        try {
          value = _joi2['default'].attempt(ast.value, schema);
        } catch (err) {
          throw new _graphql.GraphQLError(err.message);
        }
        return value;
      }
    });
    this.schema = schema.meta({ GraphQLType: this });
  }

  return GraphQLJoiType;
})(_graphql.GraphQLScalarType);

exports.GraphQLJoiType = GraphQLJoiType;
var GraphQLDateType = new GraphQLJoiType({
  name: 'email',
  schema: _joi2['default'].string().email()
});
exports.GraphQLDateType = GraphQLDateType;